PSHTRG - Editorial

PROBLEM LINK:

Div1, Div2

Practice

Author: Ivan Fekete

Tester: Triveni Mahatha

Editorialist: Adarsh Kumar

DIFFICULTY:

Medium

PREREQUISITES:

Segment tree

PROBLEM:

You are given an array with N elements. You need to support two types of operations on this array. First one is point update. For the second operation, you will be given query range l,r and you need to find the maximum possible perimeter of a triangle with non-zero area whose sides are A_x, A_y, A_z, where l \le x < y < z \le r. If no triangle can be formed, you just need to output 0.

QUICK EXPLANATION:

Build a segment tree where each node stores largest K elements from the interval. Value of K for given constraint will be around 50. Update function on the tree can now be supported in O(KlogN).

Claim: For a given range, triangle with maximum perimeter can be formed using largest K elements from that interval. Answer will be 0, only for the case, when there will be less than K elements in the interval and no triangle formation is possible.

You can query for largest K elements in O(KlogN). Finding the triangle with maximum perimeter afterward is relatively easy and procedure for the same can be found in detailed explanation.

EXPLANATION:

Let’s try to solve a simpler version first.

Solve a simple version first:

In this version, you are given an array of $N$ integers and you need to find the maximum possible perimeter of a triangle.

To solve this problem, first, we sort our array in non-ascending order. Next, we iterate over each A[i] (where 1 \le i < N-1 ) and fix the longest side, c = A[i] . To satisfy the condition a+b>c and maximize a+b+c , we must choose b = A[i+1] and a = A[i+2] . a+b+c will be the largest perimeter for minimal i satisfying the condition a+b>c. The answer will be 0 if no such i exist.

Claim: If N>K, answer always exist and can be found using largest K elements, i.e. i \le K . Here K = O(log_{\phi}(\sqrt{5}.MAX)), where \phi = \frac{1+\sqrt{5}}{2} and MAX is the maximum value which can be present in the array.

Proof: Lets say you keep adding elements in an array in increasing order such that no triangle formation is possible at any instant. Say there are r elements currently in the array, when you add (r+1)^{th} element, it must not satisy triangle inequality with any elements already present in the array. Hence we can write,

$A[r+1] \ge A[r]+A[r-1]$

If we keep on adding elements in this manner, we will end up on fibonacci sequence. Fibonacci numbers grows very fast and soon they will exceed the maximum value that can be present in the array. If we do not exceed the maximum value that can be present in the array, triangle can definitely be formed using K elements. You can compute the exact value of K, but we will just use approximation here for our purpose:

$fib(K) > MAX$

\Rightarrow \frac{\phi^K}{\sqrt{5}} > MAX (Using approximation)

\Rightarrow K > log_{\phi}(\sqrt{5}.MAX)

Conclusion: For our original purpose, we will only need largest K elements from the query range. We need a Data Structure that can support point update and can report largest K elements from any query range in logarithmic time complexity or similar. For current constraints K = 50.

Using segment tree for our purpose

We can perform our required operation with the help of segment tree. In each node of segment tree, you need to store largest K elements from that interval. If size of interval is less than K then store all elements from that interval.

Merge function for two nodes can be implemented in a manner similar to merge sort algorithm. Merging of two nodes can be done in O(K). For each update/query, you will need to change/visit atmax logN nodes. Hence the time complexity for each update/query will be O(KlogN). For more implementation details, you can have a look at attached solutions.

Time Complexity:

O(Q.K.logN)

AUTHOR’S AND TESTER’S SOLUTIONS

Setter’s solution

Tester’s solution

10 Likes

@kayak use long long for calculating answer as the answer can be the sum of three maximum integers, which will result in overflow.

Having a priority queue at each node of the segment tree would be easier I guess, my solution . Also K = 45 worked fine.

Solutions are not visible :frowning:

Wouldn’t a much simpler solution be to just make a segtree which returns the index of the max element in a range? After extracting the max index, we can save it and then point update it to 0 and then do the max query again to get the second largest. This is O(KlogN) query and O(logN) update but is much simpler.

12 Likes

I have used square root decomposition for the problem.
https://www.codechef.com/viewsolution/17760397

3 Likes

@kayak 2^31 is less than 3*10^9.

Can I get a link to nice tutorial on Segment tree ?
Btw I passes this question using sqrt decomposition. CodeChef: Practical coding for everyone
With little optimisation.

1 Like

No need to store 50 points… while merging two arrays from child nodes… we can break adding points when we get a triangle and by fibonacci it is clear that no. of points would be less than 50 always… so it would be more optimized…
sample code for merging could be…


s1=size of v1 , s2 = size of v2....
 while(i<s1 && j<s2)
  {
        if( v[k-1] + v[k-2] > v[k-3]) /// breaking condition
            return ;
        if(v1[i] > v2[j])
        v.push_back(v1[i++]);
        else
        v.push_back(v2[j++]);
        k++;
  }

I am not getting how this O(Q*N) submission of mine is getting 100 points.
My approach :
First I created a vector of pair in which i stored every element’s value and index. Then I sorted this vector.
For first query I used an algorithm similar to one used in insertion sort. And for query 2 I just traversed
the array from backward and checked the conditions for an element, whether its index is between l and r .

1 Like

I got AC with full 100 points using Square root decomposition, should have got WA, but test cases were weak. Slution

neither tester nor setter’s solution are opening… showing the error “This XML file does not appear to have any style information associated with it. The document tree is shown below.” fix it @admin

Anybody tell me why its showing WA for this solution:solution

Is there any reason to choose k=50? If Yes can some one explain?

Please can someone explain to me the math involved behind the limiting the value of K to 50 ?

harrypotter0 For mathematical calculations ,refer to this

Can anyone help me. Why this code is giving TLE?

can anyone just tell me how setter is doing without sorting nodes.

Please can someone help me in improving my solution. I have understood the concept and written a code but it is giving TLE.The complexity is Q.K.log n where k = 45. here is my code Thanks

@ista2000 can you please explain your approach. I am new to segment trees.
Thanks in Advance:)